#include "Fast.h"

double FDIIKernel[][9] = {

    { FDII_A, FDII_B, FDII_A,
      FDII_B,    0.0, FDII_B,
      FDII_A, FDII_B, FDII_A },

    { FDII_C, FDII_C, FDII_C,
      FDII_C,    0.0, FDII_C,
      FDII_C, FDII_C, FDII_C },

};

void FDIInpaint( IplImage *image, IplImage *mask, int kernel, int iter ) {
    IplImage *out = cvCloneImage( image );
    IplImage *mask2 = cvCloneImage( mask );
    CvMat *kern = cvCreateMatHeader(3, 3, CV_64FC1);
    cvSetData(kern, FDIIKernel[kernel], 3*8); // build filter kernel
    cvNot(mask2, mask2); // reverse mask
    for(int i = 0; i < iter; i++) {
        if( processEvents() ) return;
        cvFilter2D(out, out, kern);
        cvCopy(image, out, mask2);
    }
    cvCopyImage( out, image );
    cvReleaseImage( &out );
    cvReleaseImage( &mask2 );
    cvReleaseMat( &kern );
}