#ifndef _IMAGE_HEADER_INCLUDE_
#define _IMAGE_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <opencv/cv.h>
#include <opencv/highgui.h>

#define IMAGE_LUMIN_B 0.114
#define IMAGE_LUMIN_G 0.587
#define IMAGE_LUMIN_R 0.299

#define IMAGEDISPLAY_MASK_TRANSPARENCY 0.5
#define IMAGEDISPLAY_MASKCOLOR_B 0.0
#define IMAGEDISPLAY_MASKCOLOR_G 255.0
#define IMAGEDISPLAY_MASKCOLOR_R 20.0

using namespace std;
using namespace cv;

extern int iGlobalSaveCount;

void iShow( const char *fileName, IplImage *image, bool eq = false, bool save = false, float scale = 1.0 );

void iShow8( const char *fileName, IplImage *image );

void iDisplay( const char *windowName, IplImage *image, IplImage *mask, 
               bool showMask, bool save, const char *fileName, bool colorShowMask );


double iPixel( IplImage *image, int x, int y, int i = 0 );

void iSixel( IplImage *image, int x, int y, double value );


double iMinZero( double v );

double iMaxZero( double v );

double iSq( double v );

void iZero( IplImage *image );


void iMaskedCombine( IplImage *src, IplImage *dst, IplImage *mask, bool maskBinary = false, double factor = 1.0 );

IplImage * iHalf( IplImage *img );

IplImage* iCloneFloat( IplImage *image, float scale = 255.0 ) ;

void printl(const char *fmt, ...);

#endif