#include "Interface.h"

HINSTANCE hinst;

HWND UIButton(char *Caption, int x, int y, int w, int h, int ID, HWND Parent) {
    return CreateWindowEx(0, TEXT("BUTTON"), TEXT(Caption), WS_CHILD|BS_PUSHBUTTON|WS_VISIBLE, 
                          x, y, w, h, Parent , (HMENU) ID, hinst, NULL); //Makes a button
}

HWND UIWindow(char *Name, LPCTSTR classname, int x, int y, int w, int h, HWND Parent, int ID, bool Border) {
    return CreateWindowEx(0, classname, TEXT(Name), !Border ? WS_CHILD : WS_CHILD|WS_BORDER,
                          x, y, w, h, Parent , (HMENU) ID, hinst, NULL); //Makes a window
}

HWND UIForm(char *Name, LPCTSTR classname, int x, int y, int w, int h, HWND Parent, int ID) {
    return CreateWindowEx(0, classname, TEXT(Name), 
           (WS_OVERLAPPEDWINDOW | WS_SYSMENU) - (WS_MAXIMIZEBOX | WS_THICKFRAME),
                          x, y, w, h, Parent , (HMENU) ID, hinst, NULL);
}

HWND UILabel(char *Caption, int x, int y, int w, int h, int ID, HWND Parent) {
    return CreateWindowEx(0, TEXT("STATIC"), TEXT(Caption), WS_CHILD|WS_VISIBLE|SS_LEFT|WS_EX_TRANSPARENT,
                          x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
}

HWND UIComboBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent) {
    return CreateWindowEx(0, TEXT("COMBOBOX"), TEXT(Caption),
                          WS_CHILD|WS_VISIBLE|SS_LEFT|CBS_DROPDOWN|WS_VSCROLL|WS_TABSTOP,
                          x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
}

HWND UIEdit(char *Caption, int x, int y, int w, int h, int ID, HWND Parent, bool Multi, bool ReadOnly) {
    DWORD Style = Multi?WS_CHILD|WS_VISIBLE|SS_LEFT|WS_BORDER|ES_MULTILINE|ES_AUTOVSCROLL|ES_WANTRETURN|WS_VSCROLL
                  |ES_AUTOHSCROLL : WS_CHILD|WS_VISIBLE|SS_LEFT|WS_BORDER|ES_AUTOHSCROLL;
    if(ReadOnly) Style |= ES_READONLY;
    return CreateWindowEx(0, TEXT("EDIT"), TEXT(Caption), Style, x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
}   

HWND UIListBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent) {
    return CreateWindowEx(0, TEXT("LISTBOX"), TEXT(Caption),
                          WS_CHILD|WS_VISIBLE|SS_LEFT|LBS_MULTIPLESEL|WS_TABSTOP|WS_BORDER|WS_VSCROLL|LBS_NOINTEGRALHEIGHT ,
                          x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
}  

HWND UIGroupBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent) {
    return CreateWindowEx(0, TEXT("BUTTON"), TEXT(Caption), WS_CHILD|WS_VISIBLE|BS_GROUPBOX,
                          x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
}

HWND UITrackBar(int x, int y, int w, int h, int ID, HWND Parent, int mn, int mx, int init, int skip) {
    HWND th = CreateWindowEx(0, TRACKBAR_CLASS, "", WS_CHILD | WS_VISIBLE | TBS_AUTOTICKS | TBS_HORZ,
                             x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
    SendMessage( th, TBM_SETRANGE, true, MAKELONG(mn, mx));
    SendMessage( th, TBM_SETTICFREQ, skip, 0);
    SendMessage( th, TBM_SETPOS, true, init);
    return th;
}

HWND UICheckBox(char *Caption, int x, int y, int w, int h, int ID, HWND Parent, bool State) {
    HWND th = CreateWindowEx(0, TEXT("BUTTON"), TEXT(Caption), WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX,
                             x,y,w,h, Parent, (HMENU)ID, hinst, NULL);
    Button_SetCheck( th, State?BST_CHECKED:BST_UNCHECKED );
    return th;
}

void UIAddCombo(char* Caption, HWND Handle, int OptNum) {
    DWORD i = SendMessage(Handle, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)Caption);
    SendMessage(Handle, CB_SETITEMDATA, i, OptNum); 
}   

void UIResetCombo(HWND Handle) {SendMessage(Handle, CB_RESETCONTENT, 0, 0);}    
void UISelCombo(HWND Handle, int Sel) {SendMessage(Handle, CB_SETCURSEL, Sel, 0); }    
int  UIGetSelCombo(HWND Handle) {return SendMessage(Handle, CB_GETCURSEL, 0, 0); }    
void UIAddList(char* Caption, HWND Handle) {SendMessage(Handle, LB_ADDSTRING, 0, (LPARAM)(LPCSTR)Caption);} 
int  UIGetListSel(HWND Handle, int Index) {return SendMessage(Handle, LB_GETSEL, (WPARAM)Index, 0);}    
void UIResetList(HWND Handle) {SendMessage(Handle, LB_RESETCONTENT, 0, 0);}

void UIGetText(HWND Handle, char* Dest, int Len) {
    SendMessage(Handle, WM_GETTEXT, Len, (LPARAM)Dest); 
}   
void UISetText(HWND Handle, char* Text) {
    SendMessage(Handle, WM_SETTEXT, 0, (LPARAM)Text); 
}   

void UIGetEditText(char* Dest, HWND Handle, int Len, int Line) {
    *((LPWORD)Dest) = Len;
    SendMessage(Handle, EM_GETLINE, (WPARAM)Line, (LPARAM)(LPCTSTR)Dest);
}    

void UISetEditText(const char *Text, HWND Handle) {Edit_SetText(Handle, Text);}     

void UIPrintf(HDC hDC, int x, int y, const char *fmt, ...) {
    char TxtBuffer[MAX_BUFFER_SIZE]; //Printf for win32!

    va_list ap;
    va_start(ap, fmt);
    vsprintf(TxtBuffer, fmt, ap);
    va_end(ap);

    SetBkMode(hDC, TRANSPARENT);
    TextOut(hDC, x, y, TxtBuffer, strlen(TxtBuffer));
}   

void UIEditScroll(HWND Handle, int Type) {
    WPARAM ScrollType = SB_LINEDOWN;
    if(Type==0) ScrollType = SB_LINEDOWN;
    if(Type==1) ScrollType = SB_LINEUP;
    if(Type==2) ScrollType = SB_PAGEDOWN;
    if(Type==3) ScrollType = SB_PAGEUP;
    if(Type==4) ScrollType = SB_TOP;
    if(Type==5) ScrollType = SB_BOTTOM;
    SendMessage(Handle, WM_VSCROLL, (WPARAM)ScrollType, NULL);
}

int UIGetTrackBar(HWND Handle) { return SendMessage(Handle, TBM_GETPOS, 0, 0);  }
void UISetTrackBar(HWND Handle, int Value) { SendMessage(Handle, TBM_SETPOS, true, Value); }
void UISetRange(HWND Handle, int mn, int mx) { SendMessage(Handle, TBM_SETRANGE, true, MAKELONG(mn, mx)); }

void UISetTextPrintf(HWND Handle, const char *fmt, ...) {
    char TxtBuffer[MAX_BUFFER_SIZE];

    va_list ap;
    va_start(ap, fmt);
    vsprintf(TxtBuffer, fmt, ap);
    va_end(ap);

    UISetText(Handle, TxtBuffer);
}

void UISetEditTextPrintf(HWND Handle, const char *fmt, ...) {
    char TxtBuffer[MAX_BUFFER_SIZE];

    va_list ap;
    va_start(ap, fmt);
    vsprintf(TxtBuffer, fmt, ap);
    va_end(ap);

    UISetEditText(TxtBuffer, Handle);
}

bool UIGetCheckBox( HWND Handle ) { return Button_GetCheck( Handle ) == BST_CHECKED; }

RECT UIRect(int x, int y, int r, int b) {
    RECT z; z.left=x; z.top=y; z.right=r; z.bottom=b;
    return z;
}

OPENFILENAME UIGetOFN(char *file, char *filter, char *ext, HWND owner, string initialDir) {
	OPENFILENAME openFileName;

	openFileName.lStructSize = sizeof( OPENFILENAME );
	openFileName.hwndOwner = owner;
	openFileName.lpstrFilter = filter;
	openFileName.lpstrCustomFilter = NULL;
	openFileName.nMaxCustFilter = 0;
	openFileName.nFilterIndex = 0;
	openFileName.lpstrFile = file;
	openFileName.nMaxFile = MAX_PATH;
	openFileName.lpstrFileTitle = NULL;
	openFileName.nMaxFileTitle = 0;
	openFileName.lpstrInitialDir = initialDir.c_str();
	openFileName.lpstrTitle = NULL;
	openFileName.nFileOffset = 0;
	openFileName.nFileExtension = 0;
	openFileName.lpstrDefExt = ext;
	openFileName.lCustData = 0;
	openFileName.lpfnHook = NULL;
	openFileName.lpTemplateName = NULL;
	openFileName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;

    return openFileName;
}