#ifndef _LOCAL_OPTIMIZE_HEADER_INCLUDE_
#define _LOCAL_OPTIMIZE_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include "Image.h"
#include "Vector.h"
#include "Exemplar.h"

#define LOCAL_TOP_NEIGHBOUR_PATCHES 10
#define LOCAL_TOP_NEIGHBOURHOOD_SIZE 2
#define LOCAL_MAX_NEIGHBOURHOOD_SIZE 1024
#define LOCAL_DIST_SCALE 0.000001

using namespace std;
using namespace cv;

void localGetExemplarPatch(IplImage *img, IplImage *msk, IplImage *cp, int px, int py, int patchSize,
                           const vector< pair< int, int > >& sourcePatches,
                           const vector< double >& borderPriority,
                           int *destx, int *desty, bool GPU = true);

#endif
