#ifndef _MASK_EDITOR_HEADER_INCLUDE_
#define _MASK_EDITOR_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>
#include <cmath>
#include <string>
#include <vector>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include "Image.h"
#include "Toolbar.h"

#define MASK_SELECT_THRESHOLD 20

#define LOG_SCROLLBACK 20
#define LOG_BUFFERSIZE 102400
#define LOG_UIBUFFERSIZE ( (LOG_SCROLLBACK * LOG_BUFFERSIZE) + 10 )

using namespace std;
using namespace cv;

typedef enum {
    ID_MASK_MIN = 2100,
    ID_MASK_BRUSH_BUTTON,
    ID_MASK_ERASE_BUTTON,
    ID_MASK_FILL_BUTTON,
    ID_MASK_SELECT_BUTTON,
    ID_MASK_DILATE_BUTTON,
    ID_MASK_BORDER_BUTTON,
    ID_MASK_LOG,
    ID_MASK_BRUSHSIZE_TRACKBAR,
    ID_MASK_DILATE_TRACKBAR,
    ID_MASK_BORDER_TRACKBAR,
    ID_MASK_MAX
} enum_maskedit_widget_ids;

typedef enum {
    BRUSH_BRUSH = 0,
    BRUSH_ERASE,
    BRUSH_FILL,
    BRUSH_SELECT,
} enum_maskedit_brush_states;

extern HWND hMaskBrushButton;
extern HWND hMaskEraseButton;
extern HWND hMaskFillButton;
extern HWND hMaskSelectButton;
extern HWND hMaskDilateButton;
extern HWND hMaskBorderButton;

extern int maskBrushState;

void maskBuildInterface();

void maskUpdateTrackbars();

bool maskHandledEvent(int ID);

void maskCommandEvent(int ID);

void maskMouseEvent( int ev, int x, int y, int flags, void* param );

#endif
