#ifndef _VECTOR_HEADER_INCLUDE_
#define _VECTOR_HEADER_INCLUDE_

#include <cstdio>
#include <cstdlib>
#include <cmath>

struct Vector2D {
    double x;
    double y;

    Vector2D();
    Vector2D(double x, double y);
    ~Vector2D();

    Vector2D operator + ( const Vector2D& v );
    Vector2D operator - ( const Vector2D& v );
    Vector2D operator + ( const double s );
    Vector2D operator - ( const double s );
    Vector2D operator * ( const double s );
    Vector2D operator / ( const double s );
    double operator * ( const Vector2D& v );

    void operator += ( const Vector2D& v );
    void operator -= ( const Vector2D& v );
    void operator += ( const double s );
    void operator -= ( const double s );
    void operator *= ( const double s );
    void operator /= ( const double s );

    double length();
    void normalize();
};

double crossProduct( Vector2D u, Vector2D v );

#endif